#include <iostream>
#include "Student.h";
using namespace std;

int main()
{
     //3 tipa konsturktora
     /*
       1.Default konstruktor- ne sadrzi nikakve argumenete i nema parametara
       2.Parametrizvoan konstruktor - mogucnost prosledjivanja argumenata konsturktoru.
       obicno ovi argumenti pomazu inicijalizovanje objekta kada se kreira.
       3.Kopija konstruktora - je clanska funkcija koja inciijalizuje objekat koristeci
       drugi objekat iste klase.

     */
    //Destruktor - je clanska funckija koja brise objekat
    /*
        Kad se poziva? Kada se funkcija zavrsava ili program zavrsava

        Imaju isti naziv kao i klasa i znak koji ih prati ~
        Samo jedan destruktor moze postojati u klasi

        Ako ne napisemo desktruktor unutar klase, kreira se sam. Medjutim ako koristimo dinamicko dodeljivanje memorije
        defaultni konstrutkro ne radi, moramo ga rucno definisati. Sto znaci: Kada klasa sadrzi pokazivac na memoriju
        dodeljenu u klasi moramo napisati destruktor da oslobodi memoriji prije nego sto instanca klase bude unistena.
    */


    //KONSTRUKTOR i Kreiranje objekta

    //default konstrutktor
    Student s1;
    s1.prikazPodatka();
    //konsturktor sa parametrima
    Student s2("Pera","Peric","210380", 2019);
    s2.prikazPodatka();

    //Pozivanje kopije konstruktora
    Student s3 = s2; // smestamo vrednosti objekta s2 u s3
    s3.prikazPodatka();



    return 0;
}
